public class Knoten extends Baumelement{
    // Attribute
    public int daten;
    Baumelement linkerKnoten;
    Baumelement rechterKnoten;

    //Konstruktor
    public Knoten() {
        daten = -1;
        linkerKnoten = new Abschluss();
        rechterKnoten = new Abschluss();
    }

    public Knoten(int newDaten) {
        daten = newDaten;
        linkerKnoten = new Abschluss();
        rechterKnoten = new Abschluss();
    }

    public Knoten(int newDaten, Baumelement knotenLinks, Baumelement knotenRechts) {
        daten = newDaten;
        linkerKnoten = knotenLinks;
        rechterKnoten = knotenRechts;
    }
    //Methoden und Dienste
     public Knoten insert(int newDaten) {
         if (newDaten<daten) linkerKnoten = linkerKnoten.insert(newDaten);
         else if (newDaten>daten) rechterKnoten = rechterKnoten.insert(newDaten);
         return this;
    }

    public void inorder() {
        linkerKnoten.inorder();
        System.out.println(daten);
        rechterKnoten.inorder();
    }

    public void postorder() {
        linkerKnoten.inorder();
        rechterKnoten.inorder();
        System.out.println(daten);
    }

    public void preorder() {
        System.out.println(daten);
        linkerKnoten.inorder();
        rechterKnoten.inorder();
    }

    public boolean suchen(int zahl) {
        if (zahl<daten) return linkerKnoten.suchen(zahl);
        else if (zahl>daten) return rechterKnoten.suchen(zahl);
        return true;
    }

}
